
pbm.fns <- list(
                diff=function(modelfilename, testfilename, test.loc) {
                  # Produce an image of the diff
                  # Output redirection NOT platform-independent?
                  # Use connections?
                  system(paste("pnmpaste -xor ", modelfilename, " 0 0 ",
                               testfilename, " > ",
                               file.path(test.loc, "gqa.diff.pbm"),
                               sep=""))
                  system(paste("pnminvert ",
                               file.path(test.loc, "gqa.diff.pbm"), "> ",
                               file.path(test.loc, "gqa.diff2.pbm"), sep=""))
                  system(paste("pnmtopng ",
                               file.path(test.loc, "gqa.diff2.pbm"), " > ",
                               paste(gsub(".test.", ".", testfilename),
                                     ".diff.png", sep=""), sep=""))
                },
                clean=function(test.loc) {
                  file.remove(list.files(test.loc, "gqa.diff2?.pbm"))
                  file.remove(list.files(test.loc, ".pbm.diff.png"))
                })

ps.fns <- list(
               diff=function(modelfilename, testfilename, test.loc) {
                 # Produce a simple diff
                 system(paste("diff ",
                              modelfilename, " ", testfilename,
                              " > ",
                              paste(gsub(".test.", ".", testfilename),
                                    ".diff.txt", sep=""),
                              sep=""))
               },
               clean=function(test.loc) {
                 file.remove(list.files(test.loc, ".ps.diff.txt"))
               })

pdformat.fns <- list(
               diff=function(modelfilename, testfilename, test.loc) {
                 # Diff the original PDF 
                 system(paste("diff ",
                              gsub("[0-9]+.pdf", "", modelfilename),
                              " ",
                              gsub("[0-9]+.pdf", "", testfilename),
                              " > ",
                              paste(gsub(".test.", ".", testfilename),
                                    ".diff.txt", sep=""),
                              sep=""))
               },
               clean=function(test.loc) {
                 file.remove(list.files(test.loc, ".pdf.diff.txt"))
               })


